import Button from "@mui/material/Button"
import { useCallback } from "react"

export default function QuickSetter() {
  const url = "https://auth.hfbz.net/api/yggdrasil"

  const handleDragStart = useCallback(
    (event: React.DragEvent<HTMLButtonElement>) => {
      const uri = "authlib-injector:yggdrasil-server:" + encodeURIComponent(url)

      if (event.dataTransfer) {
        event.dataTransfer.setData("text/plain", uri)
        event.dataTransfer.dropEffect = "copy"
      }
    },
    [url]
  )

  return (
    <Button variant="contained" draggable onDragStart={handleDragStart}>
      将此按钮拖到启动器
    </Button>
  )
}